#ifdef ALL
#define CHECKA
#define CHECKB
#endif
#ifndef CHECKA
#define LIBRARY_MODULE
#endif

#include <string.h>
#include "check.hpp"
#include "window.hpp"
#include "event.hpp"


#ifdef CHECKA
CheckButton::CheckButton(const char *name,unsigned int &result,
	unsigned int setbits)
: Button(name), bits(setbits), res(result)
{
	read();
	setwidth(minwidth());
}

void CheckButton::read()
{
    if((res & bits) == bits)
    	press();
    else
    	unpress();
}

int CheckButton::writeback()
{
	if(pressed())
    	res |= bits;
    else
    	res &= ~bits;
    return 1;
}

int CheckButton::setpressed()
{
	if(testFlag(SFdisabled))
		return 0;

	int p = pressed();
	
	if(!Button::setpressed())
		return 0;
	if(p)
    	unpress();
    else
    	press();
	return 1;
}

coord CheckButton::minwidth() const
{
	return lenWithoutTilde(name()) + 2;
}

void CheckButton::paint(Rectangle r)
{
	Control::paint(r);
    window->printstring(topleft(),r,getcolor(),pressed() ? CheckOn : CheckOff);
    Point p = { left()+2, top() };
    paintWithoutTilde(window,name(),getcolor(),p,r);
}

int CheckButton::kbdevent(KeyboardEvent &e)
{
	return (e.value() == ' ') ? setpressed() : Control::kbdevent(e);
}

VObject *CheckButton::inheritingVObject()
{
	return this;
}
#endif

#ifdef CHECKB
InstantCheckButton::InstantCheckButton(const char *name,unsigned int &result,
	unsigned int setbits)
: CheckButton(name,result,setbits)
{
}

int InstantCheckButton::setpressed()
{
	if(CheckButton::setpressed())
    	{
        write();
        return 1;
        }
	return 0;
}
#endif
