#include "command.hpp"
#include "window.hpp"

Command::~Command()
{
}

int Command::v_doit(const char *)
{
	return 1;
}

Command *Command::clone() const
{
	return new Command(*this);
}

FunctionCommand::FunctionCommand(int (*function)(const char *))
: f(function)
{
}

int FunctionCommand::v_doit(const char *sender)
{
	return (*f)(sender);
}

Command *FunctionCommand::clone() const
{
	return new FunctionCommand(*this);
}

CloseCommand::CloseCommand(Window *window)
: w(window)
{
}

int CloseCommand::v_doit(const char *sender)
{
	if(w)
		{
		if(w->name() == sender)	// note - tests pointers, not values
			{
			delete this;
			return -1;		// Special value used by Application
							// item will then delete itself
			}
		delete w;
		delete this;
		return 1;
		}
	return 0;
}

Command *CloseCommand::clone() const
{
	return new CloseCommand(*this);
}

