#ifdef ALL
#define DIALOGA
#define DIALOGB
#define DIALOGC
#define DIALOGD
#define DIALOGE
#define DIALOGF
#define DIALOGG
#define DIALOGH
#endif
#ifndef DIALOGA
#define LIBRARY_MODULE
#endif

#include "dialog.hpp"
#include "applic.hpp"
#include "screen.hpp"


#ifdef DIALOGA
Dialog::Dialog(VObject *v,const char *name)
: Window(name)
{
    realign(v);
    if(v)
        add(v);
}
#endif

#ifdef DIALOGB
Dialog::Dialog(const coord l,const coord t,const coord r,const coord b,
        VObject *v,const char *name)
: Window(l,t,r,b,v,defaultColors,name)
{
    setsize(width()+2,height()+2);
    Group::move(1,1);
    move(-2,-2);
}
#endif

#ifdef DIALOGC
void Dialog::realign()
{
    realign(objects.first());
}

void Dialog::realign(VObject *v)
{
    if(v)
        {
        v->position(1,1);
        setsize(v->maxwidth()+2,v->maxheight()+2);
        placeInside(screen->rectangle());
        }
    align(AlignFlag(AFHcenter|AFVcenter),screen->rectangle());
    if(v)
        v->setsize(width()-2,height()-2);
}
#endif

#ifdef DIALOGD
void Dialog::paint(Rectangle r)
{
    Window::paint(r);

    windowCoords(r);
    Rectangle w(width(),height());

    drawbox(w,r,getcolor(),BorderFlag(BFsingle|BFtitle),name());
}
#endif

#ifdef DIALOGE
ModalDialog::ModalDialog(VObject *v,const char *name)
: Dialog(v,name), closetype(0)
{
}
#endif

#ifdef DIALOGF
ModalDialog::ModalDialog(const coord l,const coord t,const coord r,const coord b,
        VObject *v,const char *name)
: Dialog(l,t,r,b,v,name), closetype(0)
{
}
#endif

#ifdef DIALOGG
int ModalDialog::enter()
{
    application->enter(this);

    int retval = closetype;

    delete this;
    return retval;
}
#endif

#ifdef DIALOGH
int ModalDialog::closeok()
{
    closetype = 0;
    return Window::closeok();
}

int ModalDialog::cancelok()
{
    closetype = -1;
    return Window::cancelok();
}
#endif
