#include <string.h>
#include "editclus.hpp"
#include "text.hpp"
#include "layout.hpp"

EditCluster::EditCluster(const GCollection(EditControl)& c,const char *name,
	AlignFlag a,BorderFlag f)
: HCluster(name,a,f), EditControlList(c), prompts(0), fields(0)
{
    a = (AlignFlag) (a | AFHleft);
	GIterator(EditControl) next(c);
	EditControl *e;
    prompts = new VCluster("Prompts",a);
    fields = new VCluster("Fields",a);
	
	while((e = next()) != 0)
		{
		VObject *v = e->inheritingVObject();
		
		*fields + v;
		e->linkedPrompt = new FixedText(v->name());
		*prompts + e->linkedPrompt;
		}
    add1(prompts);
    add1(new Space);
    add1(fields);
    addDone();
}

VObject *EditCluster::inheritingVObject()
{
	return this;
}

void EditCluster::add(EditControl *c)
{
	if(!c)
    	return;
	VObject *v = c->inheritingVObject();

    EditControlList::add(c);
    fields->add(v);
    prompts->add(new FixedText(v->name()));
}

EditCluster& EditCluster::operator+ (const GCollection(EditControl) &c)
{
	GIterator(EditControl) next(c);
    EditControl *v;

    while((v = next()) != 0)
    	add(v);
    return *this;
}

EditHCluster::EditHCluster(const GCollection(EditControl)& c,const char *name,
	AlignFlag a,BorderFlag f)
: HCluster(name,a,f), EditControlList(c)
{
	GIterator(EditControl) next(c);
	EditControl *e;
	
	while((e = next()) != 0)
		add1(e->inheritingVObject());
	addDone();
}

VObject *EditHCluster::inheritingVObject()
{
	return this;
}

EditHCluster& EditHCluster::operator+ (const GCollection(EditControl) &c)
{
	GIterator(EditControl) next(c);
    EditControl *v;

	EditControlList::operator+(c);
    while((v = next()) != 0)
        add1(v->inheritingVObject());
	addDone();
    return *this;
}

EditVCluster::EditVCluster(const GCollection(EditControl)& c,const char *name,
	AlignFlag a,BorderFlag f)
: VCluster(name,a,f), EditControlList(c)
{
	GIterator(EditControl) next(c);
	EditControl *e;
	
	while((e = next()) != 0)
		add1(e->inheritingVObject());
	addDone();
}

VObject *EditVCluster::inheritingVObject()
{
	return this;
}

EditVCluster& EditVCluster::operator+ (const GCollection(EditControl) &c)
{
	GIterator(EditControl) next(c);
    EditControl *v;

	EditControlList::operator+(c);
    while((v = next()) != 0)
        add1(v->inheritingVObject());
	addDone();
    return *this;
}

