#ifdef ALL
#define EDITCTA
#define EDITCTB
#define EDITCTC
#define EDITCTD
#define EDITCTE
#define EDITCTF
#define EDITCTG
#define EDITCTH
#define EDITCTI
#define EDITCTJ
#define EDITCTK
#endif
#ifndef EDITCTA
#define LIBRARY_MODULE
#endif

#include <string.h>
#include "editctrl.hpp"

#ifdef EDITCTA
EditControl::EditControl()
: linkedPrompt(0)
{
}

int EditControl::valid()
{
	return 1;			// valid by default
}

void EditControl::read()
{
}

int EditControl::writeback()
{
	return 1;
}

void EditControl::enable(int on)
{
	VObject *v = inheritingVObject();

	if(v)
		{
		if(on)
			{
			v->enable();
			v->recogniseEvents();
			if(linkedPrompt)
				linkedPrompt->enable();
			}
		else
			{
			v->disable();
			v->ignoreEvents();
			if(linkedPrompt)
				linkedPrompt->disable();
			}
		}
}
#endif

#ifdef EDITCTB
EditControlList::EditControlList(EditControl *e)
{
	*this + e;
}
#endif

#ifdef EDITCTC
EditControlList::EditControlList(EditControl **e)
{
	int nitems = 0;
	
	for(EditControl **tmp = e; *tmp; tmp++)
		nitems++;
	setsize(nitems);
	while(*e)
		*this + *e++;
}
#endif

#ifdef EDITCTD
EditControlList::EditControlList(const GCollection(EditControl) &e)
: GCollection(EditControl)(e)
{
}

int EditControlList::valid()
{
	GIterator(EditControl) next(*this);
	EditControl *e;

	while((e = next()) != 0)
		if(!e->valid())
			return 0;
	return 1;
}

void EditControlList::read()
{
	GIterator(EditControl) next(*this);
	EditControl *e;

	while((e = next()) != 0)
		e->read();
}

int EditControlList::writeback()
{
	GIterator(EditControl) next(*this);
	EditControl *e;

	while((e = next()) != 0)
		e->writeback();
	return 1;
}
#endif

#ifdef EDITCTE
CloseEditButton::CloseEditButton(EditControl *e,const char *n,
	Keys hotkey,Command *cmd,ButtonDefault makedefault)
: CloseButton(n,hotkey,cmd,makedefault), editctrl(e)
{
}
#endif

#ifdef EDITCTF
CloseEditButton::CloseEditButton(EditControl *e,Command *cmd,
	ButtonDefault makedefault,const char *n)
: CloseButton(n,Knone,cmd,makedefault), editctrl(e)
{
}
#endif

#ifdef EDITCTG
int CloseEditButton::doit()
{
	return (editctrl && editctrl->write() && CloseButton::doit());
}
#endif

#ifdef EDITCTH
ResetEditButton::ResetEditButton(EditControl *e,const char *n,
	Keys hotkey,Command *cmd)
: ActiveButton(cmd,n,hotkey), editctrl(e)
{
}
#endif

#ifdef EDITCTI
int ResetEditButton::doit()
{
	if(editctrl)
		editctrl->read();
	return ActiveButton::doit();
}
#endif

#ifdef EDITCTJ
ApplyEditButton::ApplyEditButton(EditControl *e,const char *n,
	Keys hotkey,Command *cmd)
: ActiveButton(cmd,n,hotkey), editctrl(e)
{
}
#endif

#ifdef EDITCTK
int ApplyEditButton::doit()
{
	return (editctrl && editctrl->write() && ActiveButton::doit());
}
#endif
