/*
 * Inspector stuff
 */

#include <string.h>
#include "inspect.hpp"
#include "text.hpp"
#include "button.hpp"
#include "cluster.hpp"
#include "event.hpp"

#ifndef NINSPECT
class InspectButton : public ActiveButton {
    VObject *object;
public:
    InspectButton(VObject *v,const char *name = "Inspect");
    virtual int doit();
    };

InspectButton::InspectButton(VObject *v,const char *name)
: ActiveButton(0,name,KAltC), object(v)
{
}

int InspectButton::doit()
{
    if(object)
        {
        new Inspector(object);
        return 1;
        }
    return 0;
}

Inspector::Inspector(VObject* v)
: Window(new VCluster("Inspector",(AlignFlag)(AFHexpand|AFVtop),(BorderFlag)(BFdouble|BFtitle),
    new MultiLineText(v->inspectinfo()),
    new HCluster(AlignFlag(AFHexpand|AFVcenter),
        new CancelButton,
        v->getcontainer() ? new InspectButton(v->getcontainer(),"Container") : EndList,
        EndList),
    EndList),(AlignFlag)(AFHleft|AFVtop),defaultColors,"Inspector"), object(v)
{
    if(v->testFlag(SFhighlight))
        v->unhighlight();
    else
        v->highlight();
    v->draw();
    enter();
}

Inspector::~Inspector()
{
    if(object->testFlag(SFhighlight))
        object->unhighlight();
    else
        object->highlight();
    object->draw();
}

int Inspector::inspectclick(MouseEvent&)
{
    return 1;
}
#else
static char inspect[] = "Inspect not present";
#endif
