// Extra layout stuff - Spaces, Boxes, Lines etc.
#ifndef LAYOUT_HPP
#define LAYOUT_HPP
#ifndef VOBJECT_HPP
#include "vobject.hpp"
#endif

/*
Spacing used in Clusters to neaten appearance. Placing a Space in a
Cluster ensures there is at least the specified amount of space
between the adjacent items. 
*/
class Space : public VObject {
public:
	Space(coord width = 1,coord height = 1,const char *name = "Space");

	virtual coord minwidth() const;
	virtual coord minheight() const;

protected:
	coord minw, minh;
	};

/*
An empty box VObject. The type of box border can be determined
(default BFsingle), and the width and height. 
*/
class Box : public Space {
public:
	Box(coord width,coord height,BorderFlag b = BFsingle,const char *n = "Box");
	virtual void paint(Rectangle r);
private:
	BorderFlag bflag;
	};

// A simple vertical line. The line type is specified as a BorderFlag.
class VLine : public Box {
public:
	VLine(coord height = 1,BorderFlag b = BFsingle,const char *n = "VLine");
	};

// A simple horizontal line. The line type is specified as a BorderFlag.
class HLine : public Box {
public:
	HLine(coord width = 1,BorderFlag b = BFsingle,const char *n = "HLine");
	};

#endif
