//!
// Help system header
#ifndef HELP_HPP
#define HELP_HPP
#ifndef VOBJECT_HPP
#include "vobject.hpp"
#endif
#ifndef COLLECT_HPP
#include "collect.hpp"
#endif

class HelpKey {
friend class Help;
	HelpKey(const char *key,int pageno);
	~HelpKey();

#ifdef __ZTC__
	int compare(const char *key) const { return strcmpl(k,key); }
#else
	int compare(const char *key) const { return stricmp(k,key); }
#endif
	int operator==(const char *key) const { return !compare(key); }
	int page() const { return p; }
	const char *key() const { return k; }

	char *k;
	int p;
	};

declare(GCollection,HelpKey);
declare(GIterator,HelpKey);

struct HelpXref
	{
	int x, y, len;
	int pageno;
	};

class Help {
public:
	Help(const char *helpfile);
	~Help();

	int lookup(const char *key);	// -1 if not found
	int pass1();
	int pass2();
	void writeheader(int dokeys = 0);
	void writepage(int x,int y,int xref);

private:
	GCollection(HelpKey) keys;
	long *pages;
	FILE *file;
	};

#endif
