#include "panel.hpp"
#include "layout.hpp"
#include "screen.hpp"

Panel::Panel(MenuBar *menu,VObject *v,const char *n,const ColorSet &c,
    AlignFlag a)
: Window(0,0,0,0,0,c,n ? n : "Panel"), menubar(menu)
{
    int vw = v->maxwidth(), mw = menu->maxwidth();

    setsize(max(vw,mw),v->maxheight() + 2);
    placeInside(screen->rectangle());
    align(a,screen->rectangle());
    build(menu,v,n);
}

Panel::Panel(const coord l,const coord t,const coord r,const coord b,
    MenuBar *menu,VObject *v,const char *n,const ColorSet &c)
: Window(l,t,r,b,0,c,n ? n : "Panel"), menubar(menu)
{
    build(menu,v,n);
}

int Panel::setfocus(int tabstop)
{
    if(kbdfocus && kbdfocus->setfocus(tabstop))
        return 1;
    if(objects.first()->setfocus(tabstop))
        return 1;
    return 0;
}

int Panel::incfocus(int tabstop,int decrement)
{
    if(kbdfocus != objects.first())
        return objects.first()->setfocus(tabstop);
    return objects.first()->incfocus(tabstop,decrement);
}

int Panel::nextTabstop(int decrement,int wrap)
{
    return objects.first()->nextTabstop(decrement,wrap);
}

void Panel::build(MenuBar *menu,VObject *v,const char *n)
{
    v->setsize(width(),height()-2);
    v->move(0,2);
    add(v);
    menu->setwidth(width());
    add(menu);
    HLine *h = new HLine(width(),n ? BorderFlag(BFsingle|BFtitle) : BFsingle,name());
    h->move(0,1);
    add(h);
}

