// A Complete Panel - Menu Bar in a Window
#ifndef PANEL_HPP
#define PANEL_HPP
#ifndef WINDOW_HPP
#include "window.hpp"
#endif
#ifndef MENU_HPP
#include "menu.hpp"
#endif

/*
An SAA standard interaction Panel. Has a menu bar, and a client area.
Most applications will have a Panel, usually created at the start of
the application, and staying on the screen the whole time. 
*/
class Panel : public Window {
public:
	Panel(MenuBar *menu,VObject *v = 0,const char *n = 0,
		const ColorSet &c = defaultColors,
		AlignFlag a = AlignFlag(AFHexpand|AFVexpand));
	// Normal constructor. By default the Panel will take the whole screen.
	// The VObject is the client area. 
	Panel(const coord l,const coord t,const coord r,const coord b,
		MenuBar *menu,VObject *v = 0,const char *n = 0,
		const ColorSet &c = defaultColors);
	// Special constructor allowing full size control. The VObject is the
	// client area. 
	void setMenuColors(const ColorSet &c) { menubar->setMenuColors(c); }
	virtual int setfocus(int tabstop = 1);
	virtual int incfocus(int tabstop = 1,int decrement = 0);
	virtual int nextTabstop(int decrement = 0,int wrap = 0);

private:
	void build(MenuBar *menu,VObject *v,const char *n);
	MenuBar *menubar;
	};

#endif
