#ifdef ALL
#define RADIOA
#define RADIOB
#define RADIOC
#define RADIOD
#define RADIOE
#define RADIOF
#define RADIOG
#define RADIOH
#define RADIOI
#define RADIOJ
#define RADIOK
#define RADIOL
#endif
#ifndef RADIOA
#define LIBRARY_MODULE
#endif

#include <string.h>
#include "radio.hpp"
#include "window.hpp"


#ifdef RADIOA
implement(OCollection,RadioButton)

RadioButton::RadioButton(const char *name, Keys hotkey)
: Button(name, hotkey)
{
}

coord RadioButton::minwidth() const
{
    return lenWithoutTilde(name()) + 2;
}

int RadioButton::setfocus(int tabstop)
{
    if(Button::setfocus(tabstop))
        {
        setpressed();
        return 1;
        }
    return 0;
}

void RadioButton::paint(Rectangle r)
{
    VObject::paint(r);

    Point p = topleft();

    window->printstring(p,r,getcolor(),pressed() ? RadioOn : RadioOff);
    p.x += 2;
    paintWithoutTilde(window,name(),getcolor(),p,r);
}
#endif

#ifdef RADIOB
RadioButtonControl::RadioButtonControl(int &result, int hintSize)
: OneButtonController(hintSize), res(result)
{
}

RadioButtonControl::RadioButtonControl(int &result,const OCollection(Button) &buttons)
: OneButtonController(buttons,result), res(result)
{
}

void RadioButtonControl::read()
{
	setSelectionIndex(res);
}

int RadioButtonControl::writeback()
{
	int i = selectedIndex();

	if(i < 0)
		return 0;
    res = i;
    return 1;
}
#endif

#ifdef RADIOC
RadioHCluster::RadioHCluster(int &result,const char *b,...)
: HCluster("RadioHCluster",AFexpand,BFtabstop), 
    RadioButtonControl(result)
{
    va_list args;

    va_start(args,b);
    while(b)
        {
        RadioButton *btn = new RadioButton(b);
        
        RadioButtonControl::add(btn);
        HCluster::add1(btn);
        b = va_arg(args,const char *);
        }
    va_end(args);
    realign();
    read();
}

RadioHCluster::RadioHCluster(const char *name,BorderFlag f,int &result,
    const char *b,...)
: HCluster(name,AFexpand,BorderFlag(f|BFtabstop)), 
    RadioButtonControl(result)
{
    va_list args;

    va_start(args,b);
    while(b)
        {
        RadioButton *btn = new RadioButton(b);
        
        RadioButtonControl::add(btn);
        HCluster::add1(btn);
        b = va_arg(args,const char *);
        }
    va_end(args);
    realign();
    read();
}
#endif

#ifdef RADIOD
RadioHCluster::RadioHCluster(int &result,const GCollection(constchar)& c,
	const char *name,BorderFlag f)
: HCluster(name,AFexpand,BorderFlag(f|BFtabstop)), 
    RadioButtonControl(result,c.size())
{
    GIterator(constchar) next(c);
    const char *b;

    while((b = next()) != 0)
        {
        RadioButton *btn = new RadioButton(b);
        
        RadioButtonControl::add(btn);
        HCluster::add1(btn);
        }
    realign();
    read();
}

RadioHCluster::RadioHCluster(int &result,const char *name,BorderFlag f)
: HCluster(name,AFexpand,BorderFlag(f|BFtabstop)), 
    RadioButtonControl(result)
{
}
#endif

#ifdef RADIOE
int RadioHCluster::setfocus(int tabstop)
{
    kbdfocus = selected();
    return HCluster::setfocus(tabstop);
}

VObject *RadioHCluster::inheritingVObject()
{
	return this;
}

int RadioHCluster::kbdevent(KeyboardEvent& e)
{
	int r = HCluster::kbdevent(e);

	if(!r)
		r = RadioButtonControl::kbdevent(e);
	return r;
}
#endif

#ifdef RADIOF
RadioVCluster::RadioVCluster(int &result,const char *b,...)
: VCluster("RadioVCluster",AFcenter,BFtabstop), 
    RadioButtonControl(result)
{
    va_list args;

    va_start(args,b);
    while(b)
        {
        RadioButton *btn = new RadioButton(b);
        
        RadioButtonControl::add(btn);
        VCluster::add1(btn);
        b = va_arg(args,const char *);
        }
    va_end(args);
    realign();
    read();
}

RadioVCluster::RadioVCluster(const char *name,BorderFlag f,int &result,
    const char *b,...)
: VCluster(name,AFexpand,BorderFlag(f|BFtabstop)), 
    RadioButtonControl(result)
{
    va_list args;

    va_start(args,b);
    while(b)
        {
        RadioButton *btn = new RadioButton(b);
        
        RadioButtonControl::add(btn);
        VCluster::add1(btn);
        b = va_arg(args,const char *);
        }
    va_end(args);
    realign();
    read();
}
#endif

#ifdef RADIOG
RadioVCluster::RadioVCluster(int &result,const GCollection(constchar)& c,
	const char *name,BorderFlag f)
: VCluster(name,AFexpand,BorderFlag(f|BFtabstop)), 
    RadioButtonControl(result,c.size())
{
    GIterator(constchar) next(c);
    const char *b;

    while((b = next()) != 0)
        {
        RadioButton *btn = new RadioButton(b);
        
        RadioButtonControl::add(btn);
        VCluster::add1(btn);
        }
    realign();
    read();
}

RadioVCluster::RadioVCluster(int &result,const char *name,BorderFlag f)
: VCluster(name,AFexpand,BorderFlag(f|BFtabstop)), 
    RadioButtonControl(result)
{
}
#endif

#ifdef RADIOH
int RadioVCluster::setfocus(int tabstop)
{
    kbdfocus = selected();
    return VCluster::setfocus(tabstop);
}

VObject *RadioVCluster::inheritingVObject()
{
	return this;
}

int RadioVCluster::kbdevent(KeyboardEvent& e)
{
	int r = VCluster::kbdevent(e);

	if(!r)
		r = RadioButtonControl::kbdevent(e);
	return r;
}
#endif

#ifdef RADIOI
void RadioHCluster::add(Button *btn)
{
    RadioButtonControl::add(btn);
	HCluster::add(btn);
	read();
}
#endif

#ifdef RADIOJ
void RadioVCluster::add(Button *btn)
{
    RadioButtonControl::add(btn);
	VCluster::add(btn);
	read();
}
#endif

#ifdef RADIOK
RadioCCluster::RadioCCluster(int &result,const GCollection(constchar)& c,
		int rowsPerColumn, const char *name,BorderFlag f)
: CCluster(rowsPerColumn,name,AFexpand,
	BorderFlag(f|BFtabstop)), RadioButtonControl(result,c.size())
{
    GIterator(constchar) next(c);
    const char *b;

    while((b = next()) != 0)
        {
        RadioButton *btn = new RadioButton(b);
        
        RadioButtonControl::add(btn);
        CCluster::add1(btn);
        }
    realign();
    read();
}

RadioCCluster::RadioCCluster(int &result,int rowsPerColumn, 
	const char *name,BorderFlag f)
: CCluster(rowsPerColumn,name,AFexpand,
	BorderFlag(f|BFtabstop)), RadioButtonControl(result)
{
}

int RadioCCluster::setfocus(int tabstop)
{
    kbdfocus = selected();
    return CCluster::setfocus(tabstop);
}

VObject *RadioCCluster::inheritingVObject()
{
	return this;
}

int RadioCCluster::kbdevent(KeyboardEvent& e)
{
	int r = CCluster::kbdevent(e);

	if(!r)
		r = RadioButtonControl::kbdevent(e);
	return r;
}
#endif

#ifdef RADIOL
void RadioCCluster::add(Button *btn)
{
    RadioButtonControl::add(btn);
	CCluster::add(btn);
	read();
}
#endif
