#ifdef ALL
#define TIMEEDIA
#define TIMEEDIB
#define TIMEEDIC
#endif
#ifndef TIMEEDIA
#define LIBRARY_MODULE
#endif

#include <ctype.h>
#include <string.h>
#include "timeedit.hpp"

extern const char *getdigits(const char *string);

#ifdef TIMEEDIA
TimeEdit::TimeEdit(Time &t,const char *prompt)
: TextEdit((char *)t.strtime(),8,prompt,"0-9"), time(t)
{
}

int TimeEdit::setfocus(int tabstop)
{
	if(!TextEdit::setfocus(tabstop))
		return 0;
	setString(getdigits(string()));
	return 1;
}

char TimeEdit::filter(char inchar)
{
	return (isdigit(inchar) && pos < 6) ? inchar : 0;
}

#ifdef __TURBOC__
TextEdit::
#endif
Complete TimeEdit::complete()
{
	Time t(time);

	if(!t.settime(edittext))
		return Cinvalid;

	const char *s = t.strtime();
	
	if(!strcmp(s,edittext))
		return COK;
	strcpy(edittext,s);
	return Cchanged;
}

void TimeEdit::read()
{
	setString(time.strtime());
}

int TimeEdit::writeback()
{
	return time.settime(string());
}
#endif

#ifdef TIMEEDIB
DateEdit::DateEdit(Time &t,const char *prompt)
: TextEdit((char *)t.strdate(),8,prompt,"0-9"), time(t)
{
}

int DateEdit::setfocus(int tabstop)
{
	if(!TextEdit::setfocus(tabstop))
		return 0;
	setString(getdigits(string()));
	return 1;
}

#ifdef __TURBOC__
TextEdit::
#endif
Complete DateEdit::complete()
{
	Time t(time);

	if(!t.setdate(edittext))
		return Cinvalid;

	const char *s = t.strdate();
	
	if(!strcmp(s,edittext))
		return COK;
	strcpy(edittext,s);
	return Cchanged;
}

void DateEdit::read()
{
	setString(time.strdate());
}

int DateEdit::writeback()
{
	return time.setdate(string());
}
#endif

#ifdef TIMEEDIC
const char *getdigits(const char *string)
{
	static char digits[9];

	for(char *d = digits; *string; string++)
		if(isdigit(*string))
			*d++ = *string;
	*d++ = 0;
	return digits;
}
#endif


