// TimeEdit - input to a Time item
#ifndef TIMEEDIT_HPP
#define TIMEEDIT_HPP
#ifndef TIME_HPP
#include "time.hpp"
#endif
#ifndef TEXTEDIT_HPP
#include "textedit.hpp"
#endif

/*
A TextEdit to allow the user to amend the time portion of a Time. It
automatically aligns itself within an EditCluster, showing the
prompt in the left-hand column, and the time itself in the right-
hand column. As this is also an EditControl, the initial value is
read from the Time on creation, and written back only when the write
method is called. Normally, TimeEdits will be written back
automatically with a CloseEditButton or an ApplyEditButton. 
*/
class TimeEdit : public TextEdit {
public:
	TimeEdit(Time &t,const char *prompt = "");

	virtual int setfocus(int tabstop = 1);
	virtual char filter(char inchar);
	virtual Complete complete();
	virtual void read();
	virtual int writeback();

private:
	Time &time;
	};

/*
A TextEdit to allow the user to amend the date portion of a Time. It
automatically aligns itself within an EditCluster, showing the
prompt in the left-hand column, and the date itself in the right-
hand column. As this is also an EditControl, the initial value is
read from the Time on creation, and written back only when the write
method is called. Normally, TimeEdits will be written back
automatically with a CloseEditButton or an ApplyEditButton. 
*/
class DateEdit : public TextEdit {
public:
	DateEdit(Time &t,const char *prompt = "");

	virtual int setfocus(int tabstop = 1);
	virtual Complete complete();
	virtual void read();
	virtual int writeback();

private:
	Time &time;
	};

#endif

